<?php
    
    namespace common\models;
    
    use Yii;
    use yii\base\Model;
    use yii\data\ActiveDataProvider;
    use common\models\ProductToProject;
    
    /**
     * ProductToProjectSearch represents the model behind the search form about
     * `common\models\ProductToProject`.
     */
    class ProductToProjectSearch extends ProductToProject
    {
        
        public $variant_name;
        
        public $product_name;
        
        /**
         * @inheritdoc
         */
        public function rules()
        {
            return [
                [
                    [
                        'variant_name',
                        'product_name',
                    ],
                    'safe',
                ],
            ];
        }
        
        /**
         * @inheritdoc
         */
        public function scenarios()
        {
            // bypass scenarios() implementation in the parent class
            return Model::scenarios();
        }
        
        /**
         * Creates data provider instance with search query applied
         *
         * @param array $params
         *
         * @return ActiveDataProvider
         */
        public function search($params)
        {
            $query = ProductToProject::find()
                                     ->joinWith('productVariant.lang')
                                     ->joinWith('product.lang');
            
            // add conditions that should always apply here
            
            $dataProvider = new ActiveDataProvider([
                'query' => $query,
                'sort'  => [
                    'attributes' => [
                        'variant_name' => [
                            'asc'  => [ 'product_variant_lang.name' => SORT_ASC ],
                            'desc' => [ 'product_variant_lang.name' => SORT_DESC ],
                        ],
                        'product_name' => [
                            'asc'  => [ 'product_lang.name' => SORT_ASC ],
                            'desc' => [ 'product_lang.name' => SORT_DESC ],
                        ],
                    ],
                ],
            ]);
            
            $this->load($params);
            
            if(!$this->validate()) {
                // uncomment the following line if you do not want to return any records when validation fails
                // $query->where('0=1');
                return $dataProvider;
            }
            
            // grid filtering conditions
            $query->andFilterWhere([
                'like',
                'product_variant_lang.name',
                $this->variant_name,
            ])
                  ->andFilterWhere([
                      'like',
                      'product_lang.name',
                      $this->product_name,
                  ]);
            
            return $dataProvider;
        }
    }
